/***************************************************************************\
* Copyright (c) 2008, Claudio Pica and Agostino Patella                     *   
* All rights reserved.                                                      * 
\***************************************************************************/

#ifndef SUN_REPR_FUNC_H
#define SUN_REPR_FUNC_H

#if (NG!=4) 
#error : Mismatch between NG and representation functions!
#endif
#if (NF!=10) 
#error : Mismatch between NF and representation functions!
#endif



/*
*   _FUND_NORM2 = C(FUND)
*   _FUND_NORM2 = C(REPR)
*/
#define _FUND_NORM2 (+5.000000000000000e-01)
#define _REPR_NORM2 (+4.000000000000000e+00)

/*
*	v double matrix 10*10
*	u complex matrix 4*4
*	v is the representation of u, as element of SU(4)
*/
#define _group_represent(v,u) \
	(v).c[0] = -(-(u).c[0].im*(u).c[0].im-(u).c[0].re*(u).c[0].re+(u).c[2].im*(u).c[2].im+(u).c[2].re*(u).c[2].re); \
	(v).c[1] = -(-(u).c[1].im*(u).c[1].im-(u).c[1].re*(u).c[1].re+(u).c[3].im*(u).c[3].im+(u).c[3].re*(u).c[3].re); \
	(v).c[2] = +1.414213562373095e+00*(-(u).c[0].im*(u).c[1].re+(u).c[0].re*(u).c[1].im-(u).c[2].im*(u).c[3].re+(u).c[2].re*(u).c[3].im); \
	(v).c[3] = -1.414213562373095e+00*(-(u).c[0].im*(u).c[1].im-(u).c[0].re*(u).c[1].re+(u).c[2].im*(u).c[3].im+(u).c[2].re*(u).c[3].re); \
	(v).c[4] = +2.000000000000000e+00*(+(u).c[0].im*(u).c[2].im+(u).c[0].re*(u).c[2].re); \
	(v).c[5] = +2.000000000000000e+00*(-(u).c[0].im*(u).c[2].re+(u).c[0].re*(u).c[2].im); \
	(v).c[6] = +2.000000000000000e+00*(+(u).c[1].im*(u).c[3].im+(u).c[1].re*(u).c[3].re); \
	(v).c[7] = +2.000000000000000e+00*(-(u).c[1].im*(u).c[3].re+(u).c[1].re*(u).c[3].im); \
	(v).c[8] = +1.414213562373095e+00*(-(u).c[0].im*(u).c[3].re+(u).c[0].re*(u).c[3].im-(u).c[1].im*(u).c[2].re+(u).c[1].re*(u).c[2].im); \
	(v).c[9] = +1.414213562373095e+00*(+(u).c[0].im*(u).c[3].im+(u).c[0].re*(u).c[3].re+(u).c[1].im*(u).c[2].im+(u).c[1].re*(u).c[2].re); \
	(v).c[10] = -(-(u).c[4].im*(u).c[4].im-(u).c[4].re*(u).c[4].re+(u).c[6].im*(u).c[6].im+(u).c[6].re*(u).c[6].re); \
	(v).c[11] = -(-(u).c[5].im*(u).c[5].im-(u).c[5].re*(u).c[5].re+(u).c[7].im*(u).c[7].im+(u).c[7].re*(u).c[7].re); \
	(v).c[12] = +1.414213562373095e+00*(-(u).c[4].im*(u).c[5].re+(u).c[4].re*(u).c[5].im-(u).c[6].im*(u).c[7].re+(u).c[6].re*(u).c[7].im); \
	(v).c[13] = -1.414213562373095e+00*(-(u).c[4].im*(u).c[5].im-(u).c[4].re*(u).c[5].re+(u).c[6].im*(u).c[7].im+(u).c[6].re*(u).c[7].re); \
	(v).c[14] = +2.000000000000000e+00*(+(u).c[4].im*(u).c[6].im+(u).c[4].re*(u).c[6].re); \
	(v).c[15] = +2.000000000000000e+00*(-(u).c[4].im*(u).c[6].re+(u).c[4].re*(u).c[6].im); \
	(v).c[16] = +2.000000000000000e+00*(+(u).c[5].im*(u).c[7].im+(u).c[5].re*(u).c[7].re); \
	(v).c[17] = +2.000000000000000e+00*(-(u).c[5].im*(u).c[7].re+(u).c[5].re*(u).c[7].im); \
	(v).c[18] = +1.414213562373095e+00*(-(u).c[4].im*(u).c[7].re+(u).c[4].re*(u).c[7].im-(u).c[5].im*(u).c[6].re+(u).c[5].re*(u).c[6].im); \
	(v).c[19] = +1.414213562373095e+00*(+(u).c[4].im*(u).c[7].im+(u).c[4].re*(u).c[7].re+(u).c[5].im*(u).c[6].im+(u).c[5].re*(u).c[6].re); \
	(v).c[20] = +1.414213562373095e+00*(+(u).c[0].im*(u).c[4].re-(u).c[0].re*(u).c[4].im-(u).c[2].im*(u).c[6].re+(u).c[2].re*(u).c[6].im); \
	(v).c[21] = +1.414213562373095e+00*(+(u).c[1].im*(u).c[5].re-(u).c[1].re*(u).c[5].im-(u).c[3].im*(u).c[7].re+(u).c[3].re*(u).c[7].im); \
	(v).c[22] = -(-(u).c[0].im*(u).c[5].im-(u).c[0].re*(u).c[5].re+(u).c[1].im*(u).c[4].im+(u).c[1].re*(u).c[4].re-(u).c[2].im*(u).c[7].im-(u).c[2].re*(u).c[7].re+(u).c[3].im*(u).c[6].im+(u).c[3].re*(u).c[6].re); \
	(v).c[23] = +(u).c[0].im*(u).c[5].re-(u).c[0].re*(u).c[5].im+(u).c[1].im*(u).c[4].re-(u).c[1].re*(u).c[4].im-(u).c[2].im*(u).c[7].re+(u).c[2].re*(u).c[7].im-(u).c[3].im*(u).c[6].re+(u).c[3].re*(u).c[6].im; \
	(v).c[24] = -1.414213562373095e+00*(-(u).c[0].im*(u).c[6].re+(u).c[0].re*(u).c[6].im-(u).c[2].im*(u).c[4].re+(u).c[2].re*(u).c[4].im); \
	(v).c[25] = -1.414213562373095e+00*(-(u).c[0].im*(u).c[6].im-(u).c[0].re*(u).c[6].re+(u).c[2].im*(u).c[4].im+(u).c[2].re*(u).c[4].re); \
	(v).c[26] = -1.414213562373095e+00*(-(u).c[1].im*(u).c[7].re+(u).c[1].re*(u).c[7].im-(u).c[3].im*(u).c[5].re+(u).c[3].re*(u).c[5].im); \
	(v).c[27] = -1.414213562373095e+00*(-(u).c[1].im*(u).c[7].im-(u).c[1].re*(u).c[7].re+(u).c[3].im*(u).c[5].im+(u).c[3].re*(u).c[5].re); \
	(v).c[28] = -(-(u).c[0].im*(u).c[7].im-(u).c[0].re*(u).c[7].re-(u).c[1].im*(u).c[6].im-(u).c[1].re*(u).c[6].re+(u).c[2].im*(u).c[5].im+(u).c[2].re*(u).c[5].re+(u).c[3].im*(u).c[4].im+(u).c[3].re*(u).c[4].re); \
	(v).c[29] = -(-(u).c[0].im*(u).c[7].re+(u).c[0].re*(u).c[7].im-(u).c[1].im*(u).c[6].re+(u).c[1].re*(u).c[6].im-(u).c[2].im*(u).c[5].re+(u).c[2].re*(u).c[5].im-(u).c[3].im*(u).c[4].re+(u).c[3].re*(u).c[4].im); \
	(v).c[30] = -1.414213562373095e+00*(-(u).c[0].im*(u).c[4].im-(u).c[0].re*(u).c[4].re+(u).c[2].im*(u).c[6].im+(u).c[2].re*(u).c[6].re); \
	(v).c[31] = -1.414213562373095e+00*(-(u).c[1].im*(u).c[5].im-(u).c[1].re*(u).c[5].re+(u).c[3].im*(u).c[7].im+(u).c[3].re*(u).c[7].re); \
	(v).c[32] = -(+(u).c[0].im*(u).c[5].re-(u).c[0].re*(u).c[5].im-(u).c[1].im*(u).c[4].re+(u).c[1].re*(u).c[4].im+(u).c[2].im*(u).c[7].re-(u).c[2].re*(u).c[7].im-(u).c[3].im*(u).c[6].re+(u).c[3].re*(u).c[6].im); \
	(v).c[33] = -(-(u).c[0].im*(u).c[5].im-(u).c[0].re*(u).c[5].re-(u).c[1].im*(u).c[4].im-(u).c[1].re*(u).c[4].re+(u).c[2].im*(u).c[7].im+(u).c[2].re*(u).c[7].re+(u).c[3].im*(u).c[6].im+(u).c[3].re*(u).c[6].re); \
	(v).c[34] = +1.414213562373095e+00*(+(u).c[0].im*(u).c[6].im+(u).c[0].re*(u).c[6].re+(u).c[2].im*(u).c[4].im+(u).c[2].re*(u).c[4].re); \
	(v).c[35] = -1.414213562373095e+00*(+(u).c[0].im*(u).c[6].re-(u).c[0].re*(u).c[6].im-(u).c[2].im*(u).c[4].re+(u).c[2].re*(u).c[4].im); \
	(v).c[36] = +1.414213562373095e+00*(+(u).c[1].im*(u).c[7].im+(u).c[1].re*(u).c[7].re+(u).c[3].im*(u).c[5].im+(u).c[3].re*(u).c[5].re); \
	(v).c[37] = -1.414213562373095e+00*(+(u).c[1].im*(u).c[7].re-(u).c[1].re*(u).c[7].im-(u).c[3].im*(u).c[5].re+(u).c[3].re*(u).c[5].im); \
	(v).c[38] = -(+(u).c[0].im*(u).c[7].re-(u).c[0].re*(u).c[7].im+(u).c[1].im*(u).c[6].re-(u).c[1].re*(u).c[6].im-(u).c[2].im*(u).c[5].re+(u).c[2].re*(u).c[5].im-(u).c[3].im*(u).c[4].re+(u).c[3].re*(u).c[4].im); \
	(v).c[39] = +(u).c[0].im*(u).c[7].im+(u).c[0].re*(u).c[7].re+(u).c[1].im*(u).c[6].im+(u).c[1].re*(u).c[6].re+(u).c[2].im*(u).c[5].im+(u).c[2].re*(u).c[5].re+(u).c[3].im*(u).c[4].im+(u).c[3].re*(u).c[4].re; \
	(v).c[40] = -2.000000000000000e+00*(-(u).c[0].im*(u).c[2].im+(u).c[0].re*(u).c[2].re); \
	(v).c[41] = -2.000000000000000e+00*(-(u).c[1].im*(u).c[3].im+(u).c[1].re*(u).c[3].re); \
	(v).c[42] = -1.414213562373095e+00*(-(u).c[0].im*(u).c[3].re-(u).c[0].re*(u).c[3].im+(u).c[1].im*(u).c[2].re+(u).c[1].re*(u).c[2].im); \
	(v).c[43] = -1.414213562373095e+00*(-(u).c[0].im*(u).c[3].im+(u).c[0].re*(u).c[3].re-(u).c[1].im*(u).c[2].im+(u).c[1].re*(u).c[2].re); \
	(v).c[44] = -(+(u).c[0].im*(u).c[0].im-(u).c[0].re*(u).c[0].re-(u).c[2].im*(u).c[2].im+(u).c[2].re*(u).c[2].re); \
	(v).c[45] = -2.000000000000000e+00*(+(u).c[0].im*(u).c[0].re+(u).c[2].im*(u).c[2].re); \
	(v).c[46] = -(+(u).c[1].im*(u).c[1].im-(u).c[1].re*(u).c[1].re-(u).c[3].im*(u).c[3].im+(u).c[3].re*(u).c[3].re); \
	(v).c[47] = -2.000000000000000e+00*(+(u).c[1].im*(u).c[1].re+(u).c[3].im*(u).c[3].re); \
	(v).c[48] = -1.414213562373095e+00*(+(u).c[0].im*(u).c[1].re+(u).c[0].re*(u).c[1].im+(u).c[2].im*(u).c[3].re+(u).c[2].re*(u).c[3].im); \
	(v).c[49] = -1.414213562373095e+00*(+(u).c[0].im*(u).c[1].im-(u).c[0].re*(u).c[1].re-(u).c[2].im*(u).c[3].im+(u).c[2].re*(u).c[3].re); \
	(v).c[50] = -2.000000000000000e+00*(+(u).c[0].im*(u).c[2].re+(u).c[0].re*(u).c[2].im); \
	(v).c[51] = -2.000000000000000e+00*(+(u).c[1].im*(u).c[3].re+(u).c[1].re*(u).c[3].im); \
	(v).c[52] = +1.414213562373095e+00*(+(u).c[0].im*(u).c[3].im-(u).c[0].re*(u).c[3].re-(u).c[1].im*(u).c[2].im+(u).c[1].re*(u).c[2].re); \
	(v).c[53] = -1.414213562373095e+00*(+(u).c[0].im*(u).c[3].re+(u).c[0].re*(u).c[3].im+(u).c[1].im*(u).c[2].re+(u).c[1].re*(u).c[2].im); \
	(v).c[54] = -2.000000000000000e+00*(-(u).c[0].im*(u).c[0].re+(u).c[2].im*(u).c[2].re); \
	(v).c[55] = -(u).c[0].im*(u).c[0].im+(u).c[0].re*(u).c[0].re-(u).c[2].im*(u).c[2].im+(u).c[2].re*(u).c[2].re; \
	(v).c[56] = -2.000000000000000e+00*(-(u).c[1].im*(u).c[1].re+(u).c[3].im*(u).c[3].re); \
	(v).c[57] = -(u).c[1].im*(u).c[1].im+(u).c[1].re*(u).c[1].re-(u).c[3].im*(u).c[3].im+(u).c[3].re*(u).c[3].re; \
	(v).c[58] = +1.414213562373095e+00*(-(u).c[0].im*(u).c[1].im+(u).c[0].re*(u).c[1].re-(u).c[2].im*(u).c[3].im+(u).c[2].re*(u).c[3].re); \
	(v).c[59] = -1.414213562373095e+00*(-(u).c[0].im*(u).c[1].re-(u).c[0].re*(u).c[1].im+(u).c[2].im*(u).c[3].re+(u).c[2].re*(u).c[3].im); \
	(v).c[60] = -2.000000000000000e+00*(-(u).c[4].im*(u).c[6].im+(u).c[4].re*(u).c[6].re); \
	(v).c[61] = -2.000000000000000e+00*(-(u).c[5].im*(u).c[7].im+(u).c[5].re*(u).c[7].re); \
	(v).c[62] = -1.414213562373095e+00*(-(u).c[4].im*(u).c[7].re-(u).c[4].re*(u).c[7].im+(u).c[5].im*(u).c[6].re+(u).c[5].re*(u).c[6].im); \
	(v).c[63] = -1.414213562373095e+00*(-(u).c[4].im*(u).c[7].im+(u).c[4].re*(u).c[7].re-(u).c[5].im*(u).c[6].im+(u).c[5].re*(u).c[6].re); \
	(v).c[64] = -(+(u).c[4].im*(u).c[4].im-(u).c[4].re*(u).c[4].re-(u).c[6].im*(u).c[6].im+(u).c[6].re*(u).c[6].re); \
	(v).c[65] = -2.000000000000000e+00*(+(u).c[4].im*(u).c[4].re+(u).c[6].im*(u).c[6].re); \
	(v).c[66] = -(+(u).c[5].im*(u).c[5].im-(u).c[5].re*(u).c[5].re-(u).c[7].im*(u).c[7].im+(u).c[7].re*(u).c[7].re); \
	(v).c[67] = -2.000000000000000e+00*(+(u).c[5].im*(u).c[5].re+(u).c[7].im*(u).c[7].re); \
	(v).c[68] = -1.414213562373095e+00*(+(u).c[4].im*(u).c[5].re+(u).c[4].re*(u).c[5].im+(u).c[6].im*(u).c[7].re+(u).c[6].re*(u).c[7].im); \
	(v).c[69] = -1.414213562373095e+00*(+(u).c[4].im*(u).c[5].im-(u).c[4].re*(u).c[5].re-(u).c[6].im*(u).c[7].im+(u).c[6].re*(u).c[7].re); \
	(v).c[70] = -2.000000000000000e+00*(+(u).c[4].im*(u).c[6].re+(u).c[4].re*(u).c[6].im); \
	(v).c[71] = -2.000000000000000e+00*(+(u).c[5].im*(u).c[7].re+(u).c[5].re*(u).c[7].im); \
	(v).c[72] = +1.414213562373095e+00*(+(u).c[4].im*(u).c[7].im-(u).c[4].re*(u).c[7].re-(u).c[5].im*(u).c[6].im+(u).c[5].re*(u).c[6].re); \
	(v).c[73] = -1.414213562373095e+00*(+(u).c[4].im*(u).c[7].re+(u).c[4].re*(u).c[7].im+(u).c[5].im*(u).c[6].re+(u).c[5].re*(u).c[6].im); \
	(v).c[74] = -2.000000000000000e+00*(-(u).c[4].im*(u).c[4].re+(u).c[6].im*(u).c[6].re); \
	(v).c[75] = -(u).c[4].im*(u).c[4].im+(u).c[4].re*(u).c[4].re-(u).c[6].im*(u).c[6].im+(u).c[6].re*(u).c[6].re; \
	(v).c[76] = -2.000000000000000e+00*(-(u).c[5].im*(u).c[5].re+(u).c[7].im*(u).c[7].re); \
	(v).c[77] = -(u).c[5].im*(u).c[5].im+(u).c[5].re*(u).c[5].re-(u).c[7].im*(u).c[7].im+(u).c[7].re*(u).c[7].re; \
	(v).c[78] = +1.414213562373095e+00*(-(u).c[4].im*(u).c[5].im+(u).c[4].re*(u).c[5].re-(u).c[6].im*(u).c[7].im+(u).c[6].re*(u).c[7].re); \
	(v).c[79] = -1.414213562373095e+00*(-(u).c[4].im*(u).c[5].re-(u).c[4].re*(u).c[5].im+(u).c[6].im*(u).c[7].re+(u).c[6].re*(u).c[7].im); \
	(v).c[80] = -1.414213562373095e+00*(+(u).c[0].im*(u).c[6].re+(u).c[0].re*(u).c[6].im+(u).c[2].im*(u).c[4].re+(u).c[2].re*(u).c[4].im); \
	(v).c[81] = -1.414213562373095e+00*(+(u).c[1].im*(u).c[7].re+(u).c[1].re*(u).c[7].im+(u).c[3].im*(u).c[5].re+(u).c[3].re*(u).c[5].im); \
	(v).c[82] = -(-(u).c[0].im*(u).c[7].im+(u).c[0].re*(u).c[7].re+(u).c[1].im*(u).c[6].im-(u).c[1].re*(u).c[6].re+(u).c[2].im*(u).c[5].im-(u).c[2].re*(u).c[5].re-(u).c[3].im*(u).c[4].im+(u).c[3].re*(u).c[4].re); \
	(v).c[83] = -(+(u).c[0].im*(u).c[7].re+(u).c[0].re*(u).c[7].im+(u).c[1].im*(u).c[6].re+(u).c[1].re*(u).c[6].im+(u).c[2].im*(u).c[5].re+(u).c[2].re*(u).c[5].im+(u).c[3].im*(u).c[4].re+(u).c[3].re*(u).c[4].im); \
	(v).c[84] = -1.414213562373095e+00*(-(u).c[0].im*(u).c[4].re-(u).c[0].re*(u).c[4].im+(u).c[2].im*(u).c[6].re+(u).c[2].re*(u).c[6].im); \
	(v).c[85] = +1.414213562373095e+00*(-(u).c[0].im*(u).c[4].im+(u).c[0].re*(u).c[4].re-(u).c[2].im*(u).c[6].im+(u).c[2].re*(u).c[6].re); \
	(v).c[86] = -1.414213562373095e+00*(-(u).c[1].im*(u).c[5].re-(u).c[1].re*(u).c[5].im+(u).c[3].im*(u).c[7].re+(u).c[3].re*(u).c[7].im); \
	(v).c[87] = +1.414213562373095e+00*(-(u).c[1].im*(u).c[5].im+(u).c[1].re*(u).c[5].re-(u).c[3].im*(u).c[7].im+(u).c[3].re*(u).c[7].re); \
	(v).c[88] = -(u).c[0].im*(u).c[5].im+(u).c[0].re*(u).c[5].re-(u).c[1].im*(u).c[4].im+(u).c[1].re*(u).c[4].re-(u).c[2].im*(u).c[7].im+(u).c[2].re*(u).c[7].re-(u).c[3].im*(u).c[6].im+(u).c[3].re*(u).c[6].re; \
	(v).c[89] = -(-(u).c[0].im*(u).c[5].re-(u).c[0].re*(u).c[5].im-(u).c[1].im*(u).c[4].re-(u).c[1].re*(u).c[4].im+(u).c[2].im*(u).c[7].re+(u).c[2].re*(u).c[7].im+(u).c[3].im*(u).c[6].re+(u).c[3].re*(u).c[6].im); \
	(v).c[90] = -1.414213562373095e+00*(-(u).c[0].im*(u).c[6].im+(u).c[0].re*(u).c[6].re-(u).c[2].im*(u).c[4].im+(u).c[2].re*(u).c[4].re); \
	(v).c[91] = -1.414213562373095e+00*(-(u).c[1].im*(u).c[7].im+(u).c[1].re*(u).c[7].re-(u).c[3].im*(u).c[5].im+(u).c[3].re*(u).c[5].re); \
	(v).c[92] = +(u).c[0].im*(u).c[7].re+(u).c[0].re*(u).c[7].im-(u).c[1].im*(u).c[6].re-(u).c[1].re*(u).c[6].im-(u).c[2].im*(u).c[5].re-(u).c[2].re*(u).c[5].im+(u).c[3].im*(u).c[4].re+(u).c[3].re*(u).c[4].im; \
	(v).c[93] = -(-(u).c[0].im*(u).c[7].im+(u).c[0].re*(u).c[7].re-(u).c[1].im*(u).c[6].im+(u).c[1].re*(u).c[6].re-(u).c[2].im*(u).c[5].im+(u).c[2].re*(u).c[5].re-(u).c[3].im*(u).c[4].im+(u).c[3].re*(u).c[4].re); \
	(v).c[94] = -1.414213562373095e+00*(+(u).c[0].im*(u).c[4].im-(u).c[0].re*(u).c[4].re-(u).c[2].im*(u).c[6].im+(u).c[2].re*(u).c[6].re); \
	(v).c[95] = -1.414213562373095e+00*(+(u).c[0].im*(u).c[4].re+(u).c[0].re*(u).c[4].im+(u).c[2].im*(u).c[6].re+(u).c[2].re*(u).c[6].im); \
	(v).c[96] = -1.414213562373095e+00*(+(u).c[1].im*(u).c[5].im-(u).c[1].re*(u).c[5].re-(u).c[3].im*(u).c[7].im+(u).c[3].re*(u).c[7].re); \
	(v).c[97] = -1.414213562373095e+00*(+(u).c[1].im*(u).c[5].re+(u).c[1].re*(u).c[5].im+(u).c[3].im*(u).c[7].re+(u).c[3].re*(u).c[7].im); \
	(v).c[98] = -(+(u).c[0].im*(u).c[5].re+(u).c[0].re*(u).c[5].im+(u).c[1].im*(u).c[4].re+(u).c[1].re*(u).c[4].im+(u).c[2].im*(u).c[7].re+(u).c[2].re*(u).c[7].im+(u).c[3].im*(u).c[6].re+(u).c[3].re*(u).c[6].im); \
	(v).c[99] = -(+(u).c[0].im*(u).c[5].im-(u).c[0].re*(u).c[5].re+(u).c[1].im*(u).c[4].im-(u).c[1].re*(u).c[4].re-(u).c[2].im*(u).c[7].im+(u).c[2].re*(u).c[7].re-(u).c[3].im*(u).c[6].im+(u).c[3].re*(u).c[6].re);


/*
*	m double matrix 10*10
*	h real 10-vector
*	m = sum(A) i*h(A)*rT(A)
*/
#define _algebra_represent(m,h) \
	(m).c[0] = 0.0; \
	(m).c[1] = 0.0; \
	(m).c[2] = +5.000000000000001e-01*(h).c[3]; \
	(m).c[3] = -5.000000000000001e-01*(h).c[2]; \
	(m).c[4] = -(h).c[5]; \
	(m).c[5] = +(h).c[4]; \
	(m).c[6] = 0.0; \
	(m).c[7] = 0.0; \
	(m).c[8] = +5.000000000000001e-01*(h).c[9]; \
	(m).c[9] = -5.000000000000001e-01*(h).c[8]; \
	(m).c[10] = 0.0; \
	(m).c[11] = 0.0; \
	(m).c[12] = -5.000000000000001e-01*(h).c[3]; \
	(m).c[13] = +5.000000000000001e-01*(h).c[2]; \
	(m).c[14] = 0.0; \
	(m).c[15] = 0.0; \
	(m).c[16] = -(h).c[7]; \
	(m).c[17] = +(h).c[6]; \
	(m).c[18] = +5.000000000000001e-01*(h).c[9]; \
	(m).c[19] = -5.000000000000001e-01*(h).c[8]; \
	(m).c[20] = -5.000000000000001e-01*(h).c[3]; \
	(m).c[21] = +5.000000000000001e-01*(h).c[3]; \
	(m).c[22] = 0.0; \
	(m).c[23] = -5.000000000000001e-01*(-(h).c[0]+(h).c[1]); \
	(m).c[24] = -5.000000000000001e-01*(h).c[9]; \
	(m).c[25] = -5.000000000000001e-01*(h).c[8]; \
	(m).c[26] = +5.000000000000001e-01*(h).c[9]; \
	(m).c[27] = +5.000000000000001e-01*(h).c[8]; \
	(m).c[28] = -5.000000000000001e-01*(-(h).c[5]+(h).c[7]); \
	(m).c[29] = -5.000000000000001e-01*(-(h).c[4]+(h).c[6]); \
	(m).c[30] = +5.000000000000001e-01*(h).c[2]; \
	(m).c[31] = -5.000000000000001e-01*(h).c[2]; \
	(m).c[32] = +5.000000000000001e-01*(-(h).c[0]+(h).c[1]); \
	(m).c[33] = 0.0; \
	(m).c[34] = -5.000000000000001e-01*(h).c[8]; \
	(m).c[35] = +5.000000000000001e-01*(h).c[9]; \
	(m).c[36] = -5.000000000000001e-01*(h).c[8]; \
	(m).c[37] = +5.000000000000001e-01*(h).c[9]; \
	(m).c[38] = +5.000000000000001e-01*(+(h).c[4]+(h).c[6]); \
	(m).c[39] = -5.000000000000001e-01*(+(h).c[5]+(h).c[7]); \
	(m).c[40] = +(h).c[5]; \
	(m).c[41] = 0.0; \
	(m).c[42] = +5.000000000000001e-01*(h).c[9]; \
	(m).c[43] = +5.000000000000001e-01*(h).c[8]; \
	(m).c[44] = 0.0; \
	(m).c[45] = -(h).c[0]; \
	(m).c[46] = 0.0; \
	(m).c[47] = 0.0; \
	(m).c[48] = -5.000000000000001e-01*(h).c[3]; \
	(m).c[49] = -5.000000000000001e-01*(h).c[2]; \
	(m).c[50] = -(h).c[4]; \
	(m).c[51] = 0.0; \
	(m).c[52] = +5.000000000000001e-01*(h).c[8]; \
	(m).c[53] = -5.000000000000001e-01*(h).c[9]; \
	(m).c[54] = +(h).c[0]; \
	(m).c[55] = 0.0; \
	(m).c[56] = 0.0; \
	(m).c[57] = 0.0; \
	(m).c[58] = -5.000000000000001e-01*(h).c[2]; \
	(m).c[59] = +5.000000000000001e-01*(h).c[3]; \
	(m).c[60] = 0.0; \
	(m).c[61] = +(h).c[7]; \
	(m).c[62] = -5.000000000000001e-01*(h).c[9]; \
	(m).c[63] = +5.000000000000001e-01*(h).c[8]; \
	(m).c[64] = 0.0; \
	(m).c[65] = 0.0; \
	(m).c[66] = 0.0; \
	(m).c[67] = -(h).c[1]; \
	(m).c[68] = -5.000000000000001e-01*(h).c[3]; \
	(m).c[69] = +5.000000000000001e-01*(h).c[2]; \
	(m).c[70] = 0.0; \
	(m).c[71] = -(h).c[6]; \
	(m).c[72] = -5.000000000000001e-01*(h).c[8]; \
	(m).c[73] = -5.000000000000001e-01*(h).c[9]; \
	(m).c[74] = 0.0; \
	(m).c[75] = 0.0; \
	(m).c[76] = +(h).c[1]; \
	(m).c[77] = 0.0; \
	(m).c[78] = +5.000000000000001e-01*(h).c[2]; \
	(m).c[79] = +5.000000000000001e-01*(h).c[3]; \
	(m).c[80] = -5.000000000000001e-01*(h).c[9]; \
	(m).c[81] = -5.000000000000001e-01*(h).c[9]; \
	(m).c[82] = +5.000000000000001e-01*(-(h).c[5]+(h).c[7]); \
	(m).c[83] = -5.000000000000001e-01*(+(h).c[4]+(h).c[6]); \
	(m).c[84] = +5.000000000000001e-01*(h).c[3]; \
	(m).c[85] = +5.000000000000001e-01*(h).c[2]; \
	(m).c[86] = +5.000000000000001e-01*(h).c[3]; \
	(m).c[87] = -5.000000000000001e-01*(h).c[2]; \
	(m).c[88] = 0.0; \
	(m).c[89] = +5.000000000000001e-01*(+(h).c[0]+(h).c[1]); \
	(m).c[90] = +5.000000000000001e-01*(h).c[8]; \
	(m).c[91] = +5.000000000000001e-01*(h).c[8]; \
	(m).c[92] = +5.000000000000001e-01*(-(h).c[4]+(h).c[6]); \
	(m).c[93] = +5.000000000000001e-01*(+(h).c[5]+(h).c[7]); \
	(m).c[94] = +5.000000000000001e-01*(h).c[2]; \
	(m).c[95] = -5.000000000000001e-01*(h).c[3]; \
	(m).c[96] = -5.000000000000001e-01*(h).c[2]; \
	(m).c[97] = -5.000000000000001e-01*(h).c[3]; \
	(m).c[98] = -5.000000000000001e-01*(+(h).c[0]+(h).c[1]); \
	(m).c[99] = 0.0;



#ifndef WITH_QUATERNIONS

/*
*	h real 10-vector
*	m double matrix 10*10
*	h(A) = -i*ReTr[rT(A).m]/C(r)
*/
#define _algebra_project(h,m) \
	(h).c[0] = +1.250000000000000e-01*(m).c[23]-1.250000000000000e-01*(m).c[32]-2.500000000000001e-01*(m).c[45]+2.500000000000001e-01*(m).c[54]+1.250000000000000e-01*(m).c[89]-1.250000000000000e-01*(m).c[98]; \
	(h).c[1] = -1.250000000000000e-01*(m).c[23]+1.250000000000000e-01*(m).c[32]-2.500000000000001e-01*(m).c[67]+2.500000000000001e-01*(m).c[76]+1.250000000000000e-01*(m).c[89]-1.250000000000000e-01*(m).c[98]; \
	(h).c[2] = -1.250000000000000e-01*(-(m).c[13]-(m).c[30]+(m).c[31]+(m).c[3]+(m).c[49]+(m).c[58]-(m).c[69]-(m).c[78]-(m).c[85]+(m).c[87]-(m).c[94]+(m).c[96]); \
	(h).c[3] = -1.250000000000000e-01*(+(m).c[12]+(m).c[20]-(m).c[21]-(m).c[2]+(m).c[48]-(m).c[59]+(m).c[68]-(m).c[79]-(m).c[84]-(m).c[86]+(m).c[95]+(m).c[97]); \
	(h).c[4] = +1.250000000000000e-01*(m).c[29]+1.250000000000000e-01*(m).c[38]-2.500000000000001e-01*(m).c[50]+2.500000000000001e-01*(m).c[5]-1.250000000000000e-01*(m).c[83]-1.250000000000000e-01*(m).c[92]; \
	(h).c[5] = +1.250000000000000e-01*(m).c[28]-1.250000000000000e-01*(m).c[39]+2.500000000000001e-01*(m).c[40]-2.500000000000001e-01*(m).c[4]-1.250000000000000e-01*(m).c[82]+1.250000000000000e-01*(m).c[93]; \
	(h).c[6] = +2.500000000000001e-01*(m).c[17]-1.250000000000000e-01*(m).c[29]+1.250000000000000e-01*(m).c[38]-2.500000000000001e-01*(m).c[71]-1.250000000000000e-01*(m).c[83]+1.250000000000000e-01*(m).c[92]; \
	(h).c[7] = -2.500000000000001e-01*(m).c[16]-1.250000000000000e-01*(m).c[28]-1.250000000000000e-01*(m).c[39]+2.500000000000001e-01*(m).c[61]+1.250000000000000e-01*(m).c[82]+1.250000000000000e-01*(m).c[93]; \
	(h).c[8] = -1.250000000000000e-01*(+(m).c[19]+(m).c[25]-(m).c[27]+(m).c[34]+(m).c[36]-(m).c[43]-(m).c[52]-(m).c[63]+(m).c[72]-(m).c[90]-(m).c[91]+(m).c[9]); \
	(h).c[9] = +1.250000000000000e-01*(+(m).c[18]-(m).c[24]+(m).c[26]+(m).c[35]+(m).c[37]+(m).c[42]-(m).c[53]-(m).c[62]-(m).c[73]-(m).c[80]-(m).c[81]+(m).c[8]);


#define _algebra_project_FMAT(h,m) _algebra_project(h,m) 


/*
*	m double matrix 4*4
*	h real 10-vector
*	m = sum(A) i*h(A)*T(A)
*/
#define _fund_algebra_represent(m,h) \
	(m).c[0].re = 0.0; \
	(m).c[0].im = +5.000000000000001e-01*(h).c[0]; \
	(m).c[1].re = -3.535533905932738e-01*(h).c[2]; \
	(m).c[1].im = +3.535533905932738e-01*(h).c[3]; \
	(m).c[2].re = -5.000000000000001e-01*(h).c[5]; \
	(m).c[2].im = +5.000000000000001e-01*(h).c[4]; \
	(m).c[3].re = -3.535533905932738e-01*(h).c[8]; \
	(m).c[3].im = +3.535533905932738e-01*(h).c[9]; \
	(m).c[4].re = +3.535533905932738e-01*(h).c[2]; \
	(m).c[4].im = +3.535533905932738e-01*(h).c[3]; \
	(m).c[5].re = 0.0; \
	(m).c[5].im = +5.000000000000001e-01*(h).c[1]; \
	(m).c[6].re = -3.535533905932738e-01*(h).c[8]; \
	(m).c[6].im = +3.535533905932738e-01*(h).c[9]; \
	(m).c[7].re = -5.000000000000001e-01*(h).c[7]; \
	(m).c[7].im = +5.000000000000001e-01*(h).c[6];



/*
*	h real 10-vector
*	m double matrix 4*4
*	h(A) = -i*ReTr[T(A).m]/C(FUND)
*/
#define _fund_algebra_project(h,m) \
	(h).c[0] = +2.000000000000000e+00*(m).c[0].im; \
	(h).c[1] = +2.000000000000000e+00*(m).c[5].im; \
	(h).c[2] = +1.414213562373095e+00*(-(m).c[1].re+(m).c[4].re); \
	(h).c[3] = +1.414213562373095e+00*(+(m).c[1].im+(m).c[4].im); \
	(h).c[4] = +2.000000000000000e+00*(m).c[2].im; \
	(h).c[5] = -2.000000000000000e+00*(m).c[2].re; \
	(h).c[6] = +2.000000000000000e+00*(m).c[7].im; \
	(h).c[7] = -2.000000000000000e+00*(m).c[7].re; \
	(h).c[8] = -1.414213562373095e+00*(+(m).c[3].re+(m).c[6].re); \
	(h).c[9] = +1.414213562373095e+00*(+(m).c[3].im+(m).c[6].im);



#else

/* QUATERNION CASE */
/* there is no represented field in this case */

/*
*	h real 10-vector
*	m double matrix 4*4
*	h(A) = -i*ReTr[T(A).m]/C(FUND)
*/
#define _fund_algebra_project(h,m) \
	(h).c[0] = 2.*(m).c[2]; \
	(h).c[1] = 2.*(m).c[1]; \
	(h).c[2] = 2.*(m).c[3]

/*
*	h real 10-vector
*	m double matrix 10*10
*	h(A) = -i*ReTr[rT(A).m]/C(r)
*/
#define _algebra_project(h,m) _fund_algebra_project(h,m)

/*
*	h real 10-vector
*	m double matrix 10*10
*	h(A) = -i*ReTr[rT(A).m]/C(r)
*/
#define _algebra_project_FMAT(h,m) \
	(h).c[0] = +1.250000000000000e-01*(m).c[23]-1.250000000000000e-01*(m).c[32]-2.500000000000001e-01*(m).c[45]+2.500000000000001e-01*(m).c[54]+1.250000000000000e-01*(m).c[89]-1.250000000000000e-01*(m).c[98]; \
	(h).c[1] = -1.250000000000000e-01*(m).c[23]+1.250000000000000e-01*(m).c[32]-2.500000000000001e-01*(m).c[67]+2.500000000000001e-01*(m).c[76]+1.250000000000000e-01*(m).c[89]-1.250000000000000e-01*(m).c[98]; \
	(h).c[2] = -1.250000000000000e-01*(-(m).c[13]-(m).c[30]+(m).c[31]+(m).c[3]+(m).c[49]+(m).c[58]-(m).c[69]-(m).c[78]-(m).c[85]+(m).c[87]-(m).c[94]+(m).c[96]); \
	(h).c[3] = -1.250000000000000e-01*(+(m).c[12]+(m).c[20]-(m).c[21]-(m).c[2]+(m).c[48]-(m).c[59]+(m).c[68]-(m).c[79]-(m).c[84]-(m).c[86]+(m).c[95]+(m).c[97]); \
	(h).c[4] = +1.250000000000000e-01*(m).c[29]+1.250000000000000e-01*(m).c[38]-2.500000000000001e-01*(m).c[50]+2.500000000000001e-01*(m).c[5]-1.250000000000000e-01*(m).c[83]-1.250000000000000e-01*(m).c[92]; \
	(h).c[5] = +1.250000000000000e-01*(m).c[28]-1.250000000000000e-01*(m).c[39]+2.500000000000001e-01*(m).c[40]-2.500000000000001e-01*(m).c[4]-1.250000000000000e-01*(m).c[82]+1.250000000000000e-01*(m).c[93]; \
	(h).c[6] = +2.500000000000001e-01*(m).c[17]-1.250000000000000e-01*(m).c[29]+1.250000000000000e-01*(m).c[38]-2.500000000000001e-01*(m).c[71]-1.250000000000000e-01*(m).c[83]+1.250000000000000e-01*(m).c[92]; \
	(h).c[7] = -2.500000000000001e-01*(m).c[16]-1.250000000000000e-01*(m).c[28]-1.250000000000000e-01*(m).c[39]+2.500000000000001e-01*(m).c[61]+1.250000000000000e-01*(m).c[82]+1.250000000000000e-01*(m).c[93]; \
	(h).c[8] = -1.250000000000000e-01*(+(m).c[19]+(m).c[25]-(m).c[27]+(m).c[34]+(m).c[36]-(m).c[43]-(m).c[52]-(m).c[63]+(m).c[72]-(m).c[90]-(m).c[91]+(m).c[9]); \
	(h).c[9] = +1.250000000000000e-01*(+(m).c[18]-(m).c[24]+(m).c[26]+(m).c[35]+(m).c[37]+(m).c[42]-(m).c[53]-(m).c[62]-(m).c[73]-(m).c[80]-(m).c[81]+(m).c[8]);



/*
*	m double matrix 4*4
*	h real 10-vector
*	m = sum(A) i*h(A)*T(A)
*/
#define _fund_algebra_represent(m,h) \
	(m).c[2] = 0.5*(h).c[0]; \
	(m).c[1] = 0.5*(h).c[1]; \
	(m).c[3] = 0.5*(h).c[2]; \
	(m).c[0] = 0.
    

#endif 

#endif 
