/***************************************************************************\
* Copyright (c) 2008, Claudio Pica and Agostino Patella                     *   
* All rights reserved.                                                      * 
\***************************************************************************/

#ifndef SUN_REPR_FUNC_H
#define SUN_REPR_FUNC_H

#if (NG!=3) 
#error : Mismatch between NG and representation functions!
#endif
#if (NF!=6) 
#error : Mismatch between NF and representation functions!
#endif



/*
*   _FUND_NORM2 = C(FUND)
*   _FUND_NORM2 = C(REPR)
*/
#define _FUND_NORM2 (+5.000000000000000e-01)
#define _REPR_NORM2 (+2.500000000000000e+00)

/*
*	v COMPLEX matrix 6*6
*	u complex matrix 3*3
*	v is the representation of u, as element of SU(3)
*/
#define _group_represent(v,u) \
	(v).c[0].re = -(u).c[0].im*(u).c[0].im+(u).c[0].re*(u).c[0].re; \
	(v).c[0].im = +2.000000000000000e+00*(u).c[0].im*(u).c[0].re; \
	(v).c[1].re = +1.414213562373095e+00*(-(u).c[0].im*(u).c[1].im+(u).c[0].re*(u).c[1].re); \
	(v).c[1].im = +1.414213562373095e+00*(+(u).c[0].im*(u).c[1].re+(u).c[0].re*(u).c[1].im); \
	(v).c[2].re = -(u).c[1].im*(u).c[1].im+(u).c[1].re*(u).c[1].re; \
	(v).c[2].im = +2.000000000000000e+00*(u).c[1].im*(u).c[1].re; \
	(v).c[3].re = +1.414213562373095e+00*(-(u).c[0].im*(u).c[2].im+(u).c[0].re*(u).c[2].re); \
	(v).c[3].im = +1.414213562373095e+00*(+(u).c[0].im*(u).c[2].re+(u).c[0].re*(u).c[2].im); \
	(v).c[4].re = +1.414213562373095e+00*(-(u).c[1].im*(u).c[2].im+(u).c[1].re*(u).c[2].re); \
	(v).c[4].im = +1.414213562373095e+00*(+(u).c[1].im*(u).c[2].re+(u).c[1].re*(u).c[2].im); \
	(v).c[5].re = -(u).c[2].im*(u).c[2].im+(u).c[2].re*(u).c[2].re; \
	(v).c[5].im = +2.000000000000000e+00*(u).c[2].im*(u).c[2].re; \
	(v).c[6].re = +1.414213562373095e+00*(-(u).c[0].im*(u).c[3].im+(u).c[0].re*(u).c[3].re); \
	(v).c[6].im = +1.414213562373095e+00*(+(u).c[0].im*(u).c[3].re+(u).c[0].re*(u).c[3].im); \
	(v).c[7].re = -(u).c[0].im*(u).c[4].im+(u).c[0].re*(u).c[4].re-(u).c[1].im*(u).c[3].im+(u).c[1].re*(u).c[3].re; \
	(v).c[7].im = +(u).c[0].im*(u).c[4].re+(u).c[0].re*(u).c[4].im+(u).c[1].im*(u).c[3].re+(u).c[1].re*(u).c[3].im; \
	(v).c[8].re = +1.414213562373095e+00*(-(u).c[1].im*(u).c[4].im+(u).c[1].re*(u).c[4].re); \
	(v).c[8].im = +1.414213562373095e+00*(+(u).c[1].im*(u).c[4].re+(u).c[1].re*(u).c[4].im); \
	(v).c[9].re = -(u).c[0].im*(u).c[5].im+(u).c[0].re*(u).c[5].re-(u).c[2].im*(u).c[3].im+(u).c[2].re*(u).c[3].re; \
	(v).c[9].im = +(u).c[0].im*(u).c[5].re+(u).c[0].re*(u).c[5].im+(u).c[2].im*(u).c[3].re+(u).c[2].re*(u).c[3].im; \
	(v).c[10].re = -(u).c[1].im*(u).c[5].im+(u).c[1].re*(u).c[5].re-(u).c[2].im*(u).c[4].im+(u).c[2].re*(u).c[4].re; \
	(v).c[10].im = +(u).c[1].im*(u).c[5].re+(u).c[1].re*(u).c[5].im+(u).c[2].im*(u).c[4].re+(u).c[2].re*(u).c[4].im; \
	(v).c[11].re = +1.414213562373095e+00*(-(u).c[2].im*(u).c[5].im+(u).c[2].re*(u).c[5].re); \
	(v).c[11].im = +1.414213562373095e+00*(+(u).c[2].im*(u).c[5].re+(u).c[2].re*(u).c[5].im); \
	(v).c[12].re = -(u).c[3].im*(u).c[3].im+(u).c[3].re*(u).c[3].re; \
	(v).c[12].im = +2.000000000000000e+00*(u).c[3].im*(u).c[3].re; \
	(v).c[13].re = +1.414213562373095e+00*(-(u).c[3].im*(u).c[4].im+(u).c[3].re*(u).c[4].re); \
	(v).c[13].im = +1.414213562373095e+00*(+(u).c[3].im*(u).c[4].re+(u).c[3].re*(u).c[4].im); \
	(v).c[14].re = -(u).c[4].im*(u).c[4].im+(u).c[4].re*(u).c[4].re; \
	(v).c[14].im = +2.000000000000000e+00*(u).c[4].im*(u).c[4].re; \
	(v).c[15].re = +1.414213562373095e+00*(-(u).c[3].im*(u).c[5].im+(u).c[3].re*(u).c[5].re); \
	(v).c[15].im = +1.414213562373095e+00*(+(u).c[3].im*(u).c[5].re+(u).c[3].re*(u).c[5].im); \
	(v).c[16].re = +1.414213562373095e+00*(-(u).c[4].im*(u).c[5].im+(u).c[4].re*(u).c[5].re); \
	(v).c[16].im = +1.414213562373095e+00*(+(u).c[4].im*(u).c[5].re+(u).c[4].re*(u).c[5].im); \
	(v).c[17].re = -(u).c[5].im*(u).c[5].im+(u).c[5].re*(u).c[5].re; \
	(v).c[17].im = +2.000000000000000e+00*(u).c[5].im*(u).c[5].re; \
	(v).c[18].re = +1.414213562373095e+00*(-(u).c[0].im*(u).c[6].im+(u).c[0].re*(u).c[6].re); \
	(v).c[18].im = +1.414213562373095e+00*(+(u).c[0].im*(u).c[6].re+(u).c[0].re*(u).c[6].im); \
	(v).c[19].re = -(u).c[0].im*(u).c[7].im+(u).c[0].re*(u).c[7].re-(u).c[1].im*(u).c[6].im+(u).c[1].re*(u).c[6].re; \
	(v).c[19].im = +(u).c[0].im*(u).c[7].re+(u).c[0].re*(u).c[7].im+(u).c[1].im*(u).c[6].re+(u).c[1].re*(u).c[6].im; \
	(v).c[20].re = +1.414213562373095e+00*(-(u).c[1].im*(u).c[7].im+(u).c[1].re*(u).c[7].re); \
	(v).c[20].im = +1.414213562373095e+00*(+(u).c[1].im*(u).c[7].re+(u).c[1].re*(u).c[7].im); \
	(v).c[21].re = -(u).c[0].im*(u).c[8].im+(u).c[0].re*(u).c[8].re-(u).c[2].im*(u).c[6].im+(u).c[2].re*(u).c[6].re; \
	(v).c[21].im = +(u).c[0].im*(u).c[8].re+(u).c[0].re*(u).c[8].im+(u).c[2].im*(u).c[6].re+(u).c[2].re*(u).c[6].im; \
	(v).c[22].re = -(u).c[1].im*(u).c[8].im+(u).c[1].re*(u).c[8].re-(u).c[2].im*(u).c[7].im+(u).c[2].re*(u).c[7].re; \
	(v).c[22].im = +(u).c[1].im*(u).c[8].re+(u).c[1].re*(u).c[8].im+(u).c[2].im*(u).c[7].re+(u).c[2].re*(u).c[7].im; \
	(v).c[23].re = +1.414213562373095e+00*(-(u).c[2].im*(u).c[8].im+(u).c[2].re*(u).c[8].re); \
	(v).c[23].im = +1.414213562373095e+00*(+(u).c[2].im*(u).c[8].re+(u).c[2].re*(u).c[8].im); \
	(v).c[24].re = +1.414213562373095e+00*(-(u).c[3].im*(u).c[6].im+(u).c[3].re*(u).c[6].re); \
	(v).c[24].im = +1.414213562373095e+00*(+(u).c[3].im*(u).c[6].re+(u).c[3].re*(u).c[6].im); \
	(v).c[25].re = -(u).c[3].im*(u).c[7].im+(u).c[3].re*(u).c[7].re-(u).c[4].im*(u).c[6].im+(u).c[4].re*(u).c[6].re; \
	(v).c[25].im = +(u).c[3].im*(u).c[7].re+(u).c[3].re*(u).c[7].im+(u).c[4].im*(u).c[6].re+(u).c[4].re*(u).c[6].im; \
	(v).c[26].re = +1.414213562373095e+00*(-(u).c[4].im*(u).c[7].im+(u).c[4].re*(u).c[7].re); \
	(v).c[26].im = +1.414213562373095e+00*(+(u).c[4].im*(u).c[7].re+(u).c[4].re*(u).c[7].im); \
	(v).c[27].re = -(u).c[3].im*(u).c[8].im+(u).c[3].re*(u).c[8].re-(u).c[5].im*(u).c[6].im+(u).c[5].re*(u).c[6].re; \
	(v).c[27].im = +(u).c[3].im*(u).c[8].re+(u).c[3].re*(u).c[8].im+(u).c[5].im*(u).c[6].re+(u).c[5].re*(u).c[6].im; \
	(v).c[28].re = -(u).c[4].im*(u).c[8].im+(u).c[4].re*(u).c[8].re-(u).c[5].im*(u).c[7].im+(u).c[5].re*(u).c[7].re; \
	(v).c[28].im = +(u).c[4].im*(u).c[8].re+(u).c[4].re*(u).c[8].im+(u).c[5].im*(u).c[7].re+(u).c[5].re*(u).c[7].im; \
	(v).c[29].re = +1.414213562373095e+00*(-(u).c[5].im*(u).c[8].im+(u).c[5].re*(u).c[8].re); \
	(v).c[29].im = +1.414213562373095e+00*(+(u).c[5].im*(u).c[8].re+(u).c[5].re*(u).c[8].im); \
	(v).c[30].re = -(u).c[6].im*(u).c[6].im+(u).c[6].re*(u).c[6].re; \
	(v).c[30].im = +2.000000000000000e+00*(u).c[6].im*(u).c[6].re; \
	(v).c[31].re = +1.414213562373095e+00*(-(u).c[6].im*(u).c[7].im+(u).c[6].re*(u).c[7].re); \
	(v).c[31].im = +1.414213562373095e+00*(+(u).c[6].im*(u).c[7].re+(u).c[6].re*(u).c[7].im); \
	(v).c[32].re = -(u).c[7].im*(u).c[7].im+(u).c[7].re*(u).c[7].re; \
	(v).c[32].im = +2.000000000000000e+00*(u).c[7].im*(u).c[7].re; \
	(v).c[33].re = +1.414213562373095e+00*(-(u).c[6].im*(u).c[8].im+(u).c[6].re*(u).c[8].re); \
	(v).c[33].im = +1.414213562373095e+00*(+(u).c[6].im*(u).c[8].re+(u).c[6].re*(u).c[8].im); \
	(v).c[34].re = +1.414213562373095e+00*(-(u).c[7].im*(u).c[8].im+(u).c[7].re*(u).c[8].re); \
	(v).c[34].im = +1.414213562373095e+00*(+(u).c[7].im*(u).c[8].re+(u).c[7].re*(u).c[8].im); \
	(v).c[35].re = -(u).c[8].im*(u).c[8].im+(u).c[8].re*(u).c[8].re; \
	(v).c[35].im = +2.000000000000000e+00*(u).c[8].im*(u).c[8].re;


/*
*	m COMPLEX matrix 6*6
*	h real 8-vector
*	m = sum(A) i*h(A)*rT(A)
*/
#define _algebra_represent(m,h) \
	(m).c[0].re = 0.0; \
	(m).c[0].im = +(h).c[3]+5.773502691896257e-01*(h).c[7]; \
	(m).c[1].re = -7.071067811865476e-01*(h).c[0]; \
	(m).c[1].im = +7.071067811865476e-01*(h).c[2]; \
	(m).c[2].re = 0.0; \
	(m).c[2].im = 0.0; \
	(m).c[3].re = -7.071067811865476e-01*(h).c[1]; \
	(m).c[3].im = +7.071067811865476e-01*(h).c[5]; \
	(m).c[4].re = 0.0; \
	(m).c[4].im = 0.0; \
	(m).c[5].re = 0.0; \
	(m).c[5].im = 0.0; \
	(m).c[6].re = +7.071067811865476e-01*(h).c[0]; \
	(m).c[6].im = +7.071067811865476e-01*(h).c[2]; \
	(m).c[7].re = 0.0; \
	(m).c[7].im = +5.773502691896258e-01*(h).c[7]; \
	(m).c[8].re = -7.071067811865476e-01*(h).c[0]; \
	(m).c[8].im = +7.071067811865476e-01*(h).c[2]; \
	(m).c[9].re = -5.000000000000001e-01*(h).c[4]; \
	(m).c[9].im = +5.000000000000001e-01*(h).c[6]; \
	(m).c[10].re = -5.000000000000001e-01*(h).c[1]; \
	(m).c[10].im = +5.000000000000001e-01*(h).c[5]; \
	(m).c[11].re = 0.0; \
	(m).c[11].im = 0.0; \
	(m).c[12].re = 0.0; \
	(m).c[12].im = 0.0; \
	(m).c[13].re = +7.071067811865476e-01*(h).c[0]; \
	(m).c[13].im = +7.071067811865476e-01*(h).c[2]; \
	(m).c[14].re = 0.0; \
	(m).c[14].im = -(h).c[3]+5.773502691896257e-01*(h).c[7]; \
	(m).c[15].re = 0.0; \
	(m).c[15].im = 0.0; \
	(m).c[16].re = -7.071067811865476e-01*(h).c[4]; \
	(m).c[16].im = +7.071067811865476e-01*(h).c[6]; \
	(m).c[17].re = 0.0; \
	(m).c[17].im = 0.0; \
	(m).c[18].re = +7.071067811865476e-01*(h).c[1]; \
	(m).c[18].im = +7.071067811865476e-01*(h).c[5]; \
	(m).c[19].re = +5.000000000000001e-01*(h).c[4]; \
	(m).c[19].im = +5.000000000000001e-01*(h).c[6]; \
	(m).c[20].re = 0.0; \
	(m).c[20].im = 0.0; \
	(m).c[21].re = 0.0; \
	(m).c[21].im = +5.000000000000001e-01*(h).c[3]-2.886751345948129e-01*(h).c[7]; \
	(m).c[22].re = -5.000000000000001e-01*(h).c[0]; \
	(m).c[22].im = +5.000000000000001e-01*(h).c[2]; \
	(m).c[23].re = -7.071067811865476e-01*(h).c[1]; \
	(m).c[23].im = +7.071067811865476e-01*(h).c[5]; \
	(m).c[24].re = 0.0; \
	(m).c[24].im = 0.0; \
	(m).c[25].re = +5.000000000000001e-01*(h).c[1]; \
	(m).c[25].im = +5.000000000000001e-01*(h).c[5]; \
	(m).c[26].re = +7.071067811865476e-01*(h).c[4]; \
	(m).c[26].im = +7.071067811865476e-01*(h).c[6]; \
	(m).c[27].re = +5.000000000000001e-01*(h).c[0]; \
	(m).c[27].im = +5.000000000000001e-01*(h).c[2]; \
	(m).c[28].re = 0.0; \
	(m).c[28].im = -5.000000000000001e-01*(h).c[3]-2.886751345948129e-01*(h).c[7]; \
	(m).c[29].re = -7.071067811865476e-01*(h).c[4]; \
	(m).c[29].im = +7.071067811865476e-01*(h).c[6]; \
	(m).c[30].re = 0.0; \
	(m).c[30].im = 0.0; \
	(m).c[31].re = 0.0; \
	(m).c[31].im = 0.0; \
	(m).c[32].re = 0.0; \
	(m).c[32].im = 0.0; \
	(m).c[33].re = +7.071067811865476e-01*(h).c[1]; \
	(m).c[33].im = +7.071067811865476e-01*(h).c[5]; \
	(m).c[34].re = +7.071067811865476e-01*(h).c[4]; \
	(m).c[34].im = +7.071067811865476e-01*(h).c[6]; \
	(m).c[35].re = 0.0; \
	(m).c[35].im = -1.154700538379251e+00*(h).c[7];



#ifndef WITH_QUATERNIONS

/*
*	h real 8-vector
*	m COMPLEX matrix 6*6
*	h(A) = -i*ReTr[rT(A).m]/C(r)
*/
#define _algebra_project(h,m) \
	(h).c[0] = +2.828427124746191e-01*(m).c[13].re-2.828427124746191e-01*(m).c[1].re-2.000000000000001e-01*(m).c[22].re+2.000000000000001e-01*(m).c[27].re+2.828427124746191e-01*(m).c[6].re-2.828427124746191e-01*(m).c[8].re; \
	(h).c[1] = -2.000000000000001e-01*(m).c[10].re+2.828427124746191e-01*(m).c[18].re-2.828427124746191e-01*(m).c[23].re+2.000000000000001e-01*(m).c[25].re+2.828427124746191e-01*(m).c[33].re-2.828427124746191e-01*(m).c[3].re; \
	(h).c[2] = +2.828427124746191e-01*(m).c[13].im+2.828427124746191e-01*(m).c[1].im+2.000000000000001e-01*(m).c[22].im+2.000000000000001e-01*(m).c[27].im+2.828427124746191e-01*(m).c[6].im+2.828427124746191e-01*(m).c[8].im; \
	(h).c[3] = +4.000000000000000e-01*(m).c[0].im-4.000000000000000e-01*(m).c[14].im+2.000000000000001e-01*(m).c[21].im-2.000000000000001e-01*(m).c[28].im; \
	(h).c[4] = -2.828427124746191e-01*(m).c[16].re+2.000000000000001e-01*(m).c[19].re+2.828427124746191e-01*(m).c[26].re-2.828427124746191e-01*(m).c[29].re+2.828427124746191e-01*(m).c[34].re-2.000000000000001e-01*(m).c[9].re; \
	(h).c[5] = +2.000000000000001e-01*(m).c[10].im+2.828427124746191e-01*(m).c[18].im+2.828427124746191e-01*(m).c[23].im+2.000000000000001e-01*(m).c[25].im+2.828427124746191e-01*(m).c[33].im+2.828427124746191e-01*(m).c[3].im; \
	(h).c[6] = +2.828427124746191e-01*(m).c[16].im+2.000000000000001e-01*(m).c[19].im+2.828427124746191e-01*(m).c[26].im+2.828427124746191e-01*(m).c[29].im+2.828427124746191e-01*(m).c[34].im+2.000000000000001e-01*(m).c[9].im; \
	(h).c[7] = +2.309401076758503e-01*(m).c[0].im+2.309401076758503e-01*(m).c[14].im-1.154700538379252e-01*(m).c[21].im-1.154700538379252e-01*(m).c[28].im-4.618802153517006e-01*(m).c[35].im+2.309401076758504e-01*(m).c[7].im;


#define _algebra_project_FMAT(h,m) _algebra_project(h,m) 


/*
*	m COMPLEX matrix 3*3
*	h real 8-vector
*	m = sum(A) i*h(A)*T(A)
*/
#define _fund_algebra_represent(m,h) \
	(m).c[0].re = 0.0; \
	(m).c[0].im = +5.000000000000000e-01*(h).c[3]+2.886751345948129e-01*(h).c[7]; \
	(m).c[1].re = -5.000000000000000e-01*(h).c[0]; \
	(m).c[1].im = +5.000000000000000e-01*(h).c[2]; \
	(m).c[2].re = -5.000000000000000e-01*(h).c[1]; \
	(m).c[2].im = +5.000000000000000e-01*(h).c[5]; \
	(m).c[3].re = +5.000000000000000e-01*(h).c[0]; \
	(m).c[3].im = +5.000000000000000e-01*(h).c[2]; \
	(m).c[4].re = 0.0; \
	(m).c[4].im = -5.000000000000000e-01*(h).c[3]+2.886751345948129e-01*(h).c[7]; \
	(m).c[5].re = -5.000000000000000e-01*(h).c[4]; \
	(m).c[5].im = +5.000000000000000e-01*(h).c[6]; \
	(m).c[6].re = +5.000000000000000e-01*(h).c[1]; \
	(m).c[6].im = +5.000000000000000e-01*(h).c[5]; \
	(m).c[7].re = +5.000000000000000e-01*(h).c[4]; \
	(m).c[7].im = +5.000000000000000e-01*(h).c[6]; \
	(m).c[8].re = 0.0; \
	(m).c[8].im = -5.773502691896257e-01*(h).c[7];



/*
*	h real 8-vector
*	m COMPLEX matrix 3*3
*	h(A) = -i*ReTr[T(A).m]/C(FUND)
*/
#define _fund_algebra_project(h,m) \
	(h).c[0] = -(m).c[1].re+(m).c[3].re; \
	(h).c[1] = -(m).c[2].re+(m).c[6].re; \
	(h).c[2] = +(m).c[1].im+(m).c[3].im; \
	(h).c[3] = -(-(m).c[0].im+(m).c[4].im); \
	(h).c[4] = -(m).c[5].re+(m).c[7].re; \
	(h).c[5] = +(m).c[2].im+(m).c[6].im; \
	(h).c[6] = +(m).c[5].im+(m).c[7].im; \
	(h).c[7] = +5.773502691896257e-01*(m).c[0].im+5.773502691896257e-01*(m).c[4].im-1.154700538379251e+00*(m).c[8].im;



#else

/* QUATERNION CASE */
/* there is no represented field in this case */

/*
*	h real 8-vector
*	m COMPLEX matrix 3*3
*	h(A) = -i*ReTr[T(A).m]/C(FUND)
*/
#define _fund_algebra_project(h,m) \
	(h).c[0] = 2.*(m).c[2]; \
	(h).c[1] = 2.*(m).c[1]; \
	(h).c[2] = 2.*(m).c[3]

/*
*	h real 8-vector
*	m COMPLEX matrix 6*6
*	h(A) = -i*ReTr[rT(A).m]/C(r)
*/
#define _algebra_project(h,m) _fund_algebra_project(h,m)

/*
*	h real 8-vector
*	m COMPLEX matrix 6*6
*	h(A) = -i*ReTr[rT(A).m]/C(r)
*/
#define _algebra_project_FMAT(h,m) \
	(h).c[0] = +2.828427124746191e-01*(m).c[13].re-2.828427124746191e-01*(m).c[1].re-2.000000000000001e-01*(m).c[22].re+2.000000000000001e-01*(m).c[27].re+2.828427124746191e-01*(m).c[6].re-2.828427124746191e-01*(m).c[8].re; \
	(h).c[1] = -2.000000000000001e-01*(m).c[10].re+2.828427124746191e-01*(m).c[18].re-2.828427124746191e-01*(m).c[23].re+2.000000000000001e-01*(m).c[25].re+2.828427124746191e-01*(m).c[33].re-2.828427124746191e-01*(m).c[3].re; \
	(h).c[2] = +2.828427124746191e-01*(m).c[13].im+2.828427124746191e-01*(m).c[1].im+2.000000000000001e-01*(m).c[22].im+2.000000000000001e-01*(m).c[27].im+2.828427124746191e-01*(m).c[6].im+2.828427124746191e-01*(m).c[8].im; \
	(h).c[3] = +4.000000000000000e-01*(m).c[0].im-4.000000000000000e-01*(m).c[14].im+2.000000000000001e-01*(m).c[21].im-2.000000000000001e-01*(m).c[28].im; \
	(h).c[4] = -2.828427124746191e-01*(m).c[16].re+2.000000000000001e-01*(m).c[19].re+2.828427124746191e-01*(m).c[26].re-2.828427124746191e-01*(m).c[29].re+2.828427124746191e-01*(m).c[34].re-2.000000000000001e-01*(m).c[9].re; \
	(h).c[5] = +2.000000000000001e-01*(m).c[10].im+2.828427124746191e-01*(m).c[18].im+2.828427124746191e-01*(m).c[23].im+2.000000000000001e-01*(m).c[25].im+2.828427124746191e-01*(m).c[33].im+2.828427124746191e-01*(m).c[3].im; \
	(h).c[6] = +2.828427124746191e-01*(m).c[16].im+2.000000000000001e-01*(m).c[19].im+2.828427124746191e-01*(m).c[26].im+2.828427124746191e-01*(m).c[29].im+2.828427124746191e-01*(m).c[34].im+2.000000000000001e-01*(m).c[9].im; \
	(h).c[7] = +2.309401076758503e-01*(m).c[0].im+2.309401076758503e-01*(m).c[14].im-1.154700538379252e-01*(m).c[21].im-1.154700538379252e-01*(m).c[28].im-4.618802153517006e-01*(m).c[35].im+2.309401076758504e-01*(m).c[7].im;



/*
*	m COMPLEX matrix 3*3
*	h real 8-vector
*	m = sum(A) i*h(A)*T(A)
*/
#define _fund_algebra_represent(m,h) \
	(m).c[2] = 0.5*(h).c[0]; \
	(m).c[1] = 0.5*(h).c[1]; \
	(m).c[3] = 0.5*(h).c[2]; \
	(m).c[0] = 0.
    

#endif 

#endif 
